( ->

  plugin = (Vue) ->
    Vue.mixin
      beforeCreate: ->
        registerStore @
      init: ->
        registerStore @

  registerStore = (vm) ->
    if vm.$options.global?
      vm.$options.computed ?= {}
      if Array.isArray(vm.$options.global)
        vm.$options.global.forEach (property) ->
          vm.$options.computed[property] = new Accessor property
      else
        for key of vm.$options.global
          if typeof vm.$options.global[key] is 'function'
            vm.$options.computed[key] = new Accessor vm.$options.global[key]()
          else if typeof vm.$options.global[key] is 'string'
            vm.$options.computed[key] = new Accessor vm.$options.global[key]

  Accessor = (key) ->
      get: ->
        key.split '.'
        .reduce (pValue, cValue) ->
          pValue[cValue]
        , @$root
      set: (value) ->
        path = key.split '.'
        global = @$root
        for i in [ 0 ... path.length - 1 ]
          if global.hasOwnProperty path[i]
            global = global[path[i]]
        global[path[i]] = value

  if Vue? then Vue.use plugin
  if typeof exports is 'object' and typeof module is 'object'
    module.exports = plugin
  else if typeof define is 'function' and define.amd
    define -> plugin
  else if window?
    window.VueGlobal = plugin

)()